

import ddf.minim.*;

Minim minim;
AudioSample ballHitSnd;
AudioSample ballHitSchlaegerSnd;
AudioPlayer soundtrack;
AudioSample shoot;
AudioSample explosion;

BouncingBall ball;
Racket       schlaeger = null;
Brick[]      brickList = null;

final static int GAME_MODE_MENU      = 0;
final static int GAME_MODE_PLAY      = 1;
final static int GAME_MODE_GAMEOVER  = 2;

int          gameMode = GAME_MODE_MENU;
PShape       _menu;
PShape       _gameover;
PImage       _background;

void setup()
{
  size(800, 600);
  
  
  ball = new BouncingBall(width/2, height/2, 7);

  schlaeger = new Racket(0, height - 40, 40, 15);   

  // sound init
  minim = new Minim(this);
  ballHitSnd = minim.loadSample("hit.mp3");
  ballHitSchlaegerSnd = minim.loadSample("hitSchlaeger.mp3");
  
  explosion = minim.loadSample("explosion.wav");
  shoot  = minim.loadSample("shoot.wav"); 
  soundtrack = minim.loadFile("soundtrack.mp3");
  soundtrack.play();
  soundtrack.loop();
  
  
  
  // bild menu
  _menu = loadShape("menu.svg");
  _gameover = loadShape("gameover.svg");
  //_background  = background();
  

  smooth(); 
  noCursor();
}

void stop()
{
  soundtrack.close();
  minim.stop();
 
  super.stop();
}


float x;
float t;
float r;
void background()
  {
  pushStyle();
     {
  // ghost mode
  fill(0);
  rect(0,0,width,height);
  fill(0,0,0,50);
  rect(0,0,width,height);
  
  x = x+6;
  t = t+7;
  r = r+15;
  stroke(240);
  fill(255,255,255,100);
  ellipse(1110-x*5,300,5,5);
  ellipse(850-(x*3),200,5,5);
  ellipse(950-x*2,500,10,10);
  fill(255,255,255,100);
  ellipse(900-t*6,350,10,10);
  line(700-t*5,100,730-t*5,100);
  line(870-t*4,550,900-t*4,550);
  ellipse(200-r*7,450,6,6);
  ellipse(830-t*4,580,10,10);
  line(600-t*6,100,630-t*6,100);
  line(935-t*4,520,940-t*4,520);
  ellipse(510-r*3,470,6,6);
  fill(255,255,255,50);
  ellipse(940-x,340,10,10);
  
  if (x>= 820)
  {
    x=0;
  }
  if (t>=800)
  {
    t=0;
  }
  if (r>=700)
  {
    r=0;
  }
}

  popStyle();
    }

void initGameScene()
{
  // setzte die start posititon des balles
  ball.set(new PVector(width/2, height/2), new PVector(random(-7, 7), -7), 1);

  // erzeuge die ziegel
  brickList = new Brick[(int)random(10, 15)];
  for (int i=0;i < brickList.length;i++)
  {
    brickList[i] = new Brick(50 + i*70, 120, 60, 30);
  }
}


void draw()
{

   background();

  drawScene();
}

void drawScene()
{
  switch(gameMode)
  {
  case GAME_MODE_MENU:
    drawMenu();
    break;
  case GAME_MODE_PLAY:
    drawGame();
    break;  
  case GAME_MODE_GAMEOVER:
    drawGameOver();
    break;
  }
}

void drawMenu()
{
  pushStyle();
  shape(_menu,100,100);
  popStyle();
}

void drawGameOver()
{
  
  pushStyle();
  shape(_gameover,100,100) ;
  popStyle();
}

void drawGame()
{
  // update die daten, berechne kollisionen
  updateScene();

  // zeichne ziegel
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i] != null)
      brickList[i].brick();
  }

  // zeichne den ball
  ball.draw();
  
  if (mousePressed == true)
{
  ball.setToRacket();
}


  // zeichne schlaeger
  schlaeger.draw();
}


void keyPressed()
{
  switch(key)
  {
  case 'p':
    // start game
    gameMode = GAME_MODE_PLAY;
    initGameScene();
    break;
  case ' ':
    // end
    gameMode = GAME_MODE_MENU;
    break;
  }
}

void  updateScene()
{
  // test ob ball aus dem spielfeld ist
  if (ball._pos.y > height- ball._r)
  {
    gameMode = GAME_MODE_GAMEOVER;
    return;
  }

  // update schlaeger pos
  schlaeger.move(mouseX, mouseY);
  
  PVector hitPos = new PVector();
  float  hitV;
  float  speed;
  
  // teste ob ball den schlaeger trifft
  int retVal = schlaeger.checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir,hitPos);
  switch(retVal)
  {
  case Brick.HIT_LEFT:
     // aendere flugrichtung ball
    ball._dir.x *= -1;
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.x = schlaeger._pos.x - schlaeger._w/2 - ball._r;
    
    // spiele sound
    shoot.trigger();
    break;
  case Brick.HIT_RIGTH:
     // aendere flugrichtung ball
    ball._dir.x *= -1;
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.x = schlaeger._pos.x + schlaeger._w/2 + ball._r;

    // spiele sound
    shoot.trigger();
    break;
  case Brick.HIT_TOP:
     // aendere flugrichtung ball
    
    // anschnitt berechnen 
    hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 1;
    
    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;
    
    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y - schlaeger._h/2 - ball._r ;
    
    // spiele sound
    shoot.trigger();
    break; 
    case Brick.HIT_BOTTOM:
    
    
    // aendere flugrichtung ball

    
    // anschnitt berechnen 
    hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 0.5;
    
    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;
    
    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y + schlaeger._h/2 + ball._r ;

    // spiele sound
    shoot.trigger();
    break;
  }
  
  // test ob ball einen ziegel trifft
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i] != null)
    {
      retVal = brickList[i].checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir,hitPos);
      switch(retVal)
      {
      case Brick.HIT_LEFT:
      case Brick.HIT_RIGTH:
        // aendere flugrichtung ball
        ball._dir.x *= -1;

        // entferne ziegel aus liste
        if (brickList[i]._life > 0)
        {
        brickList[i]._life -= 1;
        }
        else
        {
        brickList[i] = null;
        }
        
        // spiele sound
        explosion.trigger();
        break;
        
        
      case Brick.HIT_TOP:
      case Brick.HIT_BOTTOM:
      
        // aendere flugrichtung ball
        
        
        ball._dir.y *= -1;

   
        
       if (retVal == Brick.HIT_TOP)
        {
       ball._pos.y = brickList[i]._pos.y - brickList[i]._h/2 - ball._r ;
         }
       else if (retVal == Brick.HIT_BOTTOM)
        {
        ball._pos.y = brickList[i]._pos.y + brickList[i]._h/2 + ball._r ;
        }
        
        
        // entferne ziegel aus liste
        if (brickList[i]._life > 0)
        {
        brickList[i]._life -= 1;
        }
        else
        {
        brickList[i] = null;
        }
        
        // spiele sound
        explosion.trigger();
        break;
      }
    }
  }
}





